<template>
  <div>
    {{ count }} / s:{{ shopCart }}
    <hr />
    {{ productId }}
    /{{ hello.productID }}
    <!-- <p
      v-show="
        productId == hello.productID
        // console.log('GetCount',this..productID
      "
    >
    {{ hello.count }}
      {{shopCart2?.count}} -->
    <!-- </p> -->
    <hr />
    h:{{ hello }} s:{{ shopCart2 }}
    <!-- {{GetCount}} -->
    <!-- {{hello}} -->
    <!-- {{ shopCart }} -->
    <!-- {{ countVuex() }} -->
    <div
      class="rounded-full border-2 border-black p-1 w-6 h-6 text-center m-auto"
      v-show="!showAddToCard"
      @click="AddToCard(productId, count, orderMin)"
      @mouseenter="count !== 0 ? showAdd() : ''"
    >
      <img
        v-if="count == 0"
        class="cursor-pointer"
        src="/Path.svg"
        alt=""
        srcset=""
      />
      <span v-else class="cursor-pointer">
        {{ count }}
      </span>
    </div>
    <div
      v-show="showAddToCard"
      @mouseenter="showAdd()"
      @mouseleave="hideAddToCard()"
      class="items-center left-10 flex flex-col rounded-md bg-[#F8F6F6] shadow-2xl p-3"
    >
      <img
        v-if="count == orderMin"
        src="/trash.svg"
        width="17.87"
        class="cursor-pointer"
        height="20"
        @click="removeAll()"
      />
      <img
        v-else
        src="/subtractionWC.svg"
        width="17.87"
        class="cursor-pointer"
        height="30"
        @click="AddToCard(productId, count, -orderMin)"
      />
      <p class="my-3">{{ count }}</p>
      <img
        src="/Path.svg"
        class="cursor-pointer"
        width="12"
        height="12"
        @click="AddToCard(productId, count, orderMin)"
      />
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions, mapMutations } from 'vuex'

export default {
  props: {
    productId: {
      required: true,
    },
    orderMin: {
      required: true,
    },
  },
  data() {
    return {
      count: 0,
      shopCart: 0,
      shopCart2: 0,
      showAddToCard: false,
    }
  },
  computed: {
    // GetCount() {
    //   this.shopCart = this.$store.getters['order/GetUserShopCart']
    // },
    ...mapGetters({
      GetCount: 'order/GetUserShopCart',
      hello: 'order/GetCountProduct',
    }),
  },

  mounted() {
    this.countVuex()
    ;(this.count =
      JSON.parse(localStorage.getItem(`product_${this.productId}`)) ?? 0),
      this.countVuex()
  },
  updated () {
  //  if(this.hello ){
  //   this.countVuex()
  //  } ;
  },
  // created() {
  //   if(process.client) {
  //   this.count =
  //     JSON.parse(localStorage.getItem(`product_${this.productId}`)) ?? 0
  //   }
  // },
  watch: {
    localStorage: {
      handler: function (newValue, oldValue) {
        //   this.count =

        console.log('localStorage', oldValue)
        console.log('localStorage', newValue)
        // this.count = newValue

        // newValue = JSON.parse(localStorage.getItem(`product_${this.productId}`)) ?? 0
      },
    },
    shopCart: {
      handler: function (newValue, oldValue) {
        console.log('shopCart', oldValue)
        console.log('shopCart', newValue)
      },
      immediate: true,
      deep: true,
    },
    count: {
      handler: function (newValue, oldValue) {
        //   this.count =
        console.log('count', newValue)
        console.log('count', newValue)

        newValue =
          JSON.parse(localStorage.getItem(`product_${this.productId}`)) ?? 0
      },
      // immediate: true,
    },
  },
  methods: {
    countVuex() {
      // this.GetCount.find((product) => product.productID == this.productId)
      // console.log('GetCount',this.GetCount)
      // console.log('hello',this.hello)

      this.shopCart = this.GetCount
      this.shopCart = this.GetCount.find(
        (product) => product.productID == this.productId
      )?.count

      // this.shopCart = this.shopCart
      // this.shopCart = this.hello
      // this.shopCart2 = this.hello.find(
      //   (product) => product.productID == this.productId
      // )
    },
    showAdd() {
      this.showAddToCard = true
    },
    hideAddToCard() {
      this.showAddToCard = false
    },
    AddToCard(productId, count, orderMin) {
      // this.shopCart = this.hello.find(
      //   (product) => product.productID == this.productId
      // )

      // this.shopCart2 = this.hello+1
      console.log('this.shopCart2',this.shopCart2)
      console.log('this.hello',this.hello)


      if (orderMin <0) {
        this.shopCart = this.hello-1
      } else {
        this.shopCart = this.hello+1
      }
      this.showAddToCard = true
      if (count == 0) {
        if (orderMin == 1) {
          this.count += orderMin
        } else if (orderMin !== 1) {
          this.count += orderMin
        }
      } else {
        if (count >= 1) {
          if (orderMin < 0) {
            this.count -= 1
          } else {
            this.count += 1
          }
        } else if (count < 1) {
          this.count += orderMin
        }
      }
      const orderDetail = {
        productId: productId,
        qty: orderMin,
        updateCount: false,
      }

      this.$store.dispatch('order/FetchFactorDtlAdd', orderDetail)
    },
    // removeToCard(productId) {
    //   if (this.count !== 0 && this.count !== this.orderMin)
    //   if (this.count == 0) {
    //     if (this.orderMin == 1) {
    //       this.count-=1
    //     } else if (this.orderMin !== 1) {
    //       this.count -= this.orderMin
    //     }
    //   } else {
    //     if (this.count >= 1) {
    //       this.count-=1
    //     } else if (this.count < 1) {
    //       this.count -= this.orderMin
    //     }
    //   }
    //   const orderDetail = {
    //     productId: productId,
    //     qty: -this.orderMin,
    //     updateCount: false,
    //   }

    //   this.$store.dispatch('order/FetchFactorDtlAdd', orderDetail)

    // },
    removeAll() {
      this.count = 0
      this.showAddToCard = false
      const orderDetail = {
        productId: productId,
        qty: 0,
        updateCount: false,
      }

      this.$store.dispatch('order/FetchFactorDtlAdd', orderDetail)
    },
    // ...mapActions({
    //   AddToCard: 'order/AddToCard',
    //   removeToCard: 'order/removeToCard',
    //   removeAll: 'order/removeAll',
    //   showAddToCard: 'order/showAddToCard',
    //   hideAddToCard: 'order/hideAddToCard',
    // }),
  },
}
</script>

<style lang="scss" scoped></style>
